"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.RealtimeListener = void 0;
var axios_1 = __importDefault(require("axios"));
var RealtimeListener = /** @class */ (function () {
    function RealtimeListener(callback, _a) {
        var _b = _a.pollInterval, pollInterval = _b === void 0 ? 1 : _b;
        if (!callback) {
            throw new Error("Callback is required");
        }
        this.pollInterval = pollInterval;
        this.callback = callback;
        this._lastItemId = null;
    }
    RealtimeListener.prototype._assert_200 = function (resp) {
        if (resp.status != 200) {
            // https://stackoverflow.com/a/66114310
            throw new Error("Got code " + resp.status + " when fetching " + axios_1["default"].getUri(resp.request));
        }
    };
    RealtimeListener.prototype._fetchItemAndDoCallback = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1["default"].get("https://hacker-news.firebaseio.com/v0/item/" + this._lastItemId + ".json")];
                    case 1:
                        resp = _a.sent();
                        this._assert_200(resp);
                        if (resp.data == null) {
                            // Retry as Hacker News items may take some time to propagate
                            return [2 /*return*/, this._fetchItemAndDoCallback()];
                        }
                        this.callback(resp.data);
                        return [2 /*return*/];
                }
            });
        });
    };
    RealtimeListener.prototype._poll = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resp, maxItem;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1["default"].get("https://hacker-news.firebaseio.com/v0/maxitem.json")];
                    case 1:
                        resp = _a.sent();
                        this._assert_200(resp);
                        maxItem = resp.data // Will be number
                        ;
                        if (!(this._lastItemId < maxItem)) return [3 /*break*/, 3];
                        this._lastItemId = maxItem;
                        return [4 /*yield*/, this._fetchItemAndDoCallback()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    RealtimeListener.prototype.start = function () {
        if (this._intervalId != undefined) {
            throw new Error("The listener has already started. To stop it, call stop().");
        }
        this._intervalId = setInterval(this._poll.bind(this), this.pollInterval * 1000);
        this._poll(); // Initial poll
        return this;
    };
    RealtimeListener.prototype.stop = function () {
        if (this._intervalId == undefined) {
            throw new Error("Listener isn't running");
        }
        clearInterval(this._intervalId);
        this._intervalId = undefined;
    };
    return RealtimeListener;
}());
exports.RealtimeListener = RealtimeListener;
/* Convinience method for creating a new RealtimeListener and calling start() */
function listen(callback, options) {
    return new RealtimeListener(callback, options).start();
}
exports["default"] = listen;
